﻿using HeuristicLab.Common;

namespace HeuristicLab.SimulationCore {
  public interface IEventQueue<TModel> : IDeepCloneable, IContent where TModel : IModel {
    bool Empty { get; }
    int Count { get; }

    IEvent<TModel> Peek();
    IEvent<TModel> Pop();
    void Push(IEvent<TModel> @event);

    IEvent<TModel> ChangeTime(IEvent<TModel> @event, double newTime);
    void Delete(IEvent<TModel> @event);

    void Clear();
  }
}
